#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen      
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  Aqua
#property indicator_color5  Magenta
#property indicator_width1  2      
#property indicator_width2  2 
#property indicator_width3  2 

//
//
//
//
//

extern int    MaPeriod        = 21;
extern int    MaMethod        = 0;
extern int    MaPrice         = 0;
extern int    MaShift         = 0;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

extern int    arrowthickness   = 1;

//
//
//
//
//

double ma[];
double maUa[];
double maUb[];
double arrUp[];
double arrDn[];
double trend[];

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
  {

   IndicatorBuffers(6);
   SetIndexBuffer(0,ma);
   SetIndexBuffer(1,maUa);
   SetIndexBuffer(2,maUb); 
   SetIndexBuffer(3,arrUp);  SetIndexStyle(3,DRAW_ARROW,0,arrowthickness); SetIndexArrow(3,233);
   SetIndexBuffer(4,arrDn);  SetIndexStyle(4,DRAW_ARROW,0,arrowthickness); SetIndexArrow(4,234);
   SetIndexBuffer(5,trend); 
   for (int i=0; i<5; i++) SetIndexShift(i,MaShift);
   
   IndicatorShortName(getAverageName(MaMethod)+")");
return(0);
}

//
//
//
//
//

int start()
{  
      int i,limit,counted_bars=IndicatorCounted();

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
                 limit=MathMin(Bars-counted_bars,Bars-1);
                 
      //
      //
      //
      //
      //
   
      if (trend[limit]==-1) CleanPoint(limit,maUa,maUb);              
      for(i=limit; i>=0; i--) ma[i] = iCustomMA(iMA(NULL,0,1,0,MODE_SMA,MaPrice,i),MaPeriod,MaMethod,i);
      for(i=limit; i>=0; i--)
      {
         maUa[i]  = EMPTY_VALUE;
         maUb[i]  = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (ma[i] > ma[i+1]) trend[i]= 1;
            if (ma[i] < ma[i+1]) trend[i]=-1;
            if (trend[i]==-1) PlotPoint(i,maUa,maUb,ma);
            
            //
            //
            //
            //
            //
      
            arrUp[i] = EMPTY_VALUE;
            arrDn[i] = EMPTY_VALUE;
            if (trend[i]!= trend[i+1])
            if (trend[i] == 1)
                  arrUp[i] = ma[i] - iATR(NULL,0,20,i)/2;
            else  arrDn[i] = ma[i] + iATR(NULL,0,20,i)/2;
          }
          
          //
          //
          //
          //
          //
      
          if (alertsOn)
          {
          if (alertsOnCurrent)
               int whichBar = 0;
          else     whichBar = 1;
          if (trend[whichBar] != trend[whichBar+1])
          if (trend[whichBar] == 1)
                doAlert("Buy");
          else  doAlert("Sell");       
   }

return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ma "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workPrices[];
double workResult[];
int    r;

double iCustomMA(double price, int period, int method, int i)
{
   if (ArraySize(workPrices)!= Bars) ArrayResize(workPrices,Bars);
            r = Bars-i-1;
   workPrices[r] = price;

   //
   //
   //
   //
   //
   
      switch(method)
      {
         case  0: return(iSma(price,period,i));
         case  1: return(iEma(price,period,i));
         case  2: return(iSmma(price,period,i));
         case  3: return(iLwma(price,period,i));
         
      }
   return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iSma(double price, double period, int i)
{
   double sum = 0;
   for(int k=0; k<period && (r-k)>=0; k++) sum += workPrices[r-k];  
   if (k!=0)
         return(sum/k);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEma(double price, double period, int i)
{
   if (ArraySize(workResult)!= Bars) ArrayResize(workResult,Bars);
   double alpha = 2.0 / (1.0+period);
          workResult[r] = workResult[r-1]+alpha*(price-workResult[r-1]);
   return(workResult[r]);
}
//
//
//
//
//

double iSmma(double price, double period, int i)
{
   if (ArraySize(workResult)!= Bars) ArrayResize(workResult,Bars);
   if (i>=(Bars-period))
   {
      double sum = 0; 
         for(int k=0; k<period && (r-k)>=0; k++) sum += workPrices[r-k];  
         if (k!=0)
               workResult[i] = sum/k;
         else  workResult[i] = EMPTY_VALUE;
   }      
   else   workResult[r] = (workResult[r-1]*(period-1)+price)/period;
   return(workResult[r]);
}

//
//
//
//
//

double iLwmaprices[][3];
double iLwma(double price, double period, int i,int forValue=0)
{
   if (ArrayRange(iLwmaprices,0)!= Bars) ArrayResize(iLwmaprices,Bars);
   
   //
   //
   //
   //
   //
   
   iLwmaprices[r][forValue] = price;
      double sum  = 0;
      double sumw = 0;

      for(int k=0; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*iLwmaprices[r-k][forValue];  
      }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string methodNames[] = {"SMA","EMA","SMMA","LWMA"};
string getAverageName(int& method)
{
   method=MathMax(MathMin(method,3),0); return(methodNames[method]);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}